<?php
# -- BEGIN LICENSE BLOCK ----------------------------------
#
# This file is part of Magix CMS.
# Magix CMS, a CMS optimized for SEO
# Copyright (C) 2010 - 2011  Gerits Aurelien <aurelien@magix-cms.com>
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# -- END LICENSE BLOCK -----------------------------------
/**
 * MAGIX CMS
 * @category   extends 
 * @package    Smarty
 * @subpackage function
 * @copyright  MAGIX CMS Copyright (c) 2010 - 2011 Gerits Aurelien, 
 * http://www.magix-cms.com, http://www.magix-cjquery.com
 * @license    Dual licensed under the MIT or GPL Version 3 licenses.
 * @version    plugin version
 * @author Gérits Aurélien <aurelien@magix-cms.com> <aurelien@magix-dev.be>
 *
 */
/**
 * Smarty {widget_catalog_subcategory_display} function plugin
 *
 * Type:     function
 * Name:     widget_catalog_subcategory_display
 * Date:     
 * Purpose:  
 * Examples: 
 * 			{widget_catalog_subcategory_display
				css_param=[
					'class_container'=>'ch1-2 ch-dark',
					'class_elem' => 'child',
					'class_box' => 'box',
  					'class_name' => 'name',
					'class_img' => 'img',
					'class_desc' => 'descr'
				]
				tposition="bottom" 
				col="2"
				description=false
			}
 * Output:   
 * @link http://www.magix-dev.be
 * @author   Gerits Aurelien
 * @version  1.0
 * @param array
 * @param Smarty
 * @return string
 */
function smarty_function_widget_catalog_subcategory_display($params, $template){
	$title = $params['title']? "<p>" . $params['title'] . "</p>" : '';
  	//Paramètres des classes CSS
	if (isset($params['css_param'])) {
		if(is_array($params['css_param'])){
			$tabs = $params['css_param'];
		}else{
			trigger_error("css_param is not array");
			return;
		}
	}else{
		$tabs= array(
			'class_container'=>'ch1-2 ch-light',
			'class_elem'=>'child',
			'class_box'=>'box',
			'class_name' => 'name',
			'class_img'=>'img',
			'class_desc'=>'descr'
		);
	}
	// Variables pour les class des éléments
	$class_container = ($tabs['class_container'] != null)? ' class="' . $tabs['class_container'] . '"' : '' ;
	$class_elem = ($tabs['class_elem'] != null)?  $tabs['class_elem'] : null ;
	$class_box = ($tabs['class_box'] != null)?  ' class="' . $tabs['class_box'] . '"' : '' ;
	$class_name = ($tabs['class_name'] != null)? ' class="' . $tabs['class_name'] . '"' : '' ;
	$class_img = ($tabs['class_img'] != null)? ' class="' . $tabs['class_img'] . '"' : '' ;
	$class_desc = ($tabs['class_desc'] != null)? ' class="' . $tabs['class_desc'] . '"' : '' ;
	if(isset($_GET['idclc'])){
  		$getcat = magixcjquery_filter_isVar::isPostNumeric($_GET['idclc']);
	}
  	$tposition = $params['tposition']? $params['tposition'] : 'top';
  	$block = null;
	// Nombre de colonnes
	$last = $params['col']? $params['col'] : 0 ;
  	// Activer ou non une description
  	$description = !empty($params['description'])? true: false;
  	// Longeur description du produit
  	$length = magixcjquery_filter_isVar::isPostNumeric($params['length'])? $params['length']: 100 ;
  	// Le délimiteur pour tronqué le texte
  	$delimiter = $params['delimiter'] ? $params['delimiter'] : '';
	$i = 1;
	$filter = new magixglobal_model_imagepath();
  	if (frontend_db_block_catalog::s_sub_category_menu(frontend_model_template::current_Language(),$getcat) != null) {  
      $block .= '<div'.$class_container.'>';
      $block .= $title;
    	foreach ( frontend_db_block_catalog::s_sub_category_menu(frontend_model_template::current_Language(),$getcat) as $cat ) {
			if ($i == $last ) {
				//$class= $class_b . 'last' . $class_e;
				$last_elem = ' last';
				$i = 1;
			} else {
				//$class= null;
				$last_elem = null;
				$i++;
			}
			// Construction Description catégorie
			//----------------------------------------
			$desc_cat = '<span'.$class_desc.'>';
				$desc_cat .= magixcjquery_form_helpersforms::inputTagClean(magixcjquery_string_convert::cleanTruncate($cat['s_content'],$length,$delimiter));
			$desc_cat .= '</span>';
			$uri_subcategory = magixglobal_model_rewrite::filter_catalog_subcategory_url($cat['iso'],$cat['pathclibelle'],$cat['idclc'],$cat['pathslibelle'],$cat['idcls'],true);
      		$block .= '<div class="'.$class_elem.$last_elem.'">';
      		$block .= '<div'. $class_box .'>'."\n";
	        if($tposition == 'top'){
	        	$block .= '<p'.$class_name.'><a href="'.$uri_subcategory.'">'.magixcjquery_string_convert::ucFirst($cat['slibelle']).'</a></p>';
	        }
     		if($cat['img_s'] != null){
            	$block .= '<a'.$class_img.' href="'.$uri_subcategory.'"><img src="'.$filter->filterPathImg(array('filtermod'=>'catalog','img'=>$cat['img_s'],'levelmod'=>'subcategory')).'" alt="'.$cat['slibelle'].'" /></a>';
      		}else{
            	$block .= '<a'.$class_img.' href="'.$uri_subcategory.'"><img src="'.$filter->filterPathImg(array('img'=>'skin/'.frontend_model_template::frontendTheme()->themeSelected().'/img/catalog/no-picture.png')).'" alt="'.$cat['slibelle'].'" /></a>';
      		}
	      	if($tposition == 'bottom'){
	            $block .= '<p'.$class_name.'><a href="'.$uri_subcategory.'">'.magixcjquery_string_convert::ucFirst($cat['slibelle']).'</a></p>';
	      	}     
	      	if ($description != false) {
	      		$block .= $desc_cat;
	      	}
	      	$block .= '</div>'."\n";
     		$block .= '</div>'."\n";
    	}
    $block .= "</div>";
  }
  return $block;
} 